/*
;----------------------------------------------------------------;
;                40 New Best Routines (graphic)                  ;
;          (c) SerzhSoft, Shadrinsk, may-june, 1997              ;
;    old length: 1444 bytes         new length:  861 bytes       ;
;----------------------------------------------------------------;
; http://vladik1232008.narod.ru/ZX_FORUM_40_Best_procedures.html ;
;           Adapted to ZXDev/SDCC by Oleg N. Cher, 2012          ;
;----------------------------------------------------------------;
*/
#include "SYSTEM.h"
//#include "Best40.h"

interface

export SHORTINT Best40_attrib;

export void Best40_ASRL_LF (void);
export void Best40_ASRL_RG (void);
export void Best40_ASRL_UP (void);
export void Best40_ASRL_DN (void);
export void Best40_SSRL_LF (void);
export void Best40_SSRL_RG (void);
export void Best40_SSRL_UP (void);
export void Best40_SSRL_DN (void);
export void Best40_PSRL_LF (void);
export void Best40_PSRL_RG (void);
export void Best40_PSRL_UP (void);
export void Best40_PSRL_DN (void);
export void Best40_SCR_MRG (SYSTEM_ADDRESS scr_addr);
export void Best40_SCR_INV (void);
export void Best40_SINV_UD (SYSTEM_ADDRESS char_addr);
export void Best40_SINV_LR (SYSTEM_ADDRESS char_addr);
export void Best40_SROTATE (SYSTEM_ADDRESS char_addr);
export void Best40_ACHANGE (SHORTINT attr_and, SHORTINT attr_or);
export void Best40_AREPLC (SHORTINT attr_from, SHORTINT attr_to);
export void Best40_PAINT (SHORTINT x, SHORTINT y);
export BOOLEAN Best40_POINT (SHORTINT x, SHORTINT y);
export void Best40_PFIGURE (SHORTINT x, SHORTINT y, SYSTEM_ADDRESS pattern);
export void Best40_PSCALER (
  SHORTINT x1_old, SHORTINT y1_old, SHORTINT x2_old, SHORTINT y2_old,
  SHORTINT xscale, SHORTINT yscale, SHORTINT x_new, SHORTINT y_new);
  
implementation

SHORTINT Best40_attrib; //     
#define attrib _Best40_attrib

/*
;--------------------------------------------------------------;
;   (22<=23)
;--------------------------------------------------------------;
*/
void Best40_ASRL_LF (void)
{
__asm
          LD      DE,#0x5800   // DE=   
LP_ASLF$: LD      H,D          //  DE  HL
          LD      L,E          //    HL  :
          INC     HL           //  HL=   
          LD      BC,#0x001F   // <  > - 1
          LDIR                 //    
          LD      A,(#attrib)  //    
          LD      (DE),A       //   
          INC     DE           //     
          LD      A,D          //    ,
          CP      #0x5B        //       ,
          JR      C,LP_ASLF$   //   STOP,   
__endasm;
}//ASRL_LF

/*
;--------------------------------------------------------------;
;   (21<=23)
;--------------------------------------------------------------;
*/
void Best40_ASRL_RG (void)
{
__asm
          LD      DE,#0x5AFF   //    
LP_ASRG$: LD      H,D          //  DE  HL -
          LD      L,E          //     
          DEC     HL           //    
          LD      BC,#0x001F   // <  > - 1
          LDDR                 //    
          LD      A,(#attrib)  //    
          LD      (DE),A       //   
          DEC     DE           //     
          BIT     3,D          //      ,
          JR      NZ,LP_ASRG$  //      . 
__endasm;
}//ASRL_RG

/*
;--------------------------------------------------------------;
;   (19<=21)
;--------------------------------------------------------------;
*/
void Best40_ASRL_UP (void)
{
__asm
          LD      HL,#0x5820   //    
          LD      DE,#0x5800   //    
          LD      BC,#0x02E0   // : 23   32 
          LDIR                 //  23   
          LD      A,(#attrib)  //     
LP_ASUP$: LD      (DE),A       //   
          INC     E            //     
          JR      NZ,LP_ASUP$  //  (E=0),   
__endasm;
}//ASRL_UP

/*
;--------------------------------------------------------------;
;   (20<=21)
;--------------------------------------------------------------;
*/
void Best40_ASRL_DN (void)
{
__asm
          LD      HL,#0x5ADF   //     
          LD      DE,#0x5AFF   //     
          LD      BC,#0x02E0   // : 23   32 
          LDDR                 //  23   
          LD      A,(#attrib)  //     
LP_ASDN$: LD      (DE),A       //   
          DEC     E            //      
          JR      NZ,LP_ASDN$  //    (E=0),  STOP
          LD      (DE),A       //     
__endasm;
}//ASRL_DN

/*
;--------------------------------------------------------------;
;     (20<=21)
;--------------------------------------------------------------;
*/
void Best40_SSRL_LF (void)
{
__asm
          LD      DE,#0x4000   //   
LP_SSLF$: LD      H,D          //  
          LD      L,E          //   
          INC     HL           //    
          LD      BC,#0x001F   //   
          LDIR                 //     1 
          XOR     A            //    
          LD      (DE),A       //    ()  
          INC     DE           //     ()
          LD      A,D          //  
          CP      #0x58        //  "  ",
          JR      C,LP_SSLF$   //      . 
__endasm;
}//SSRL_LF

/*
;--------------------------------------------------------------;
;     (19<=22)
;--------------------------------------------------------------;
*/
void Best40_SSRL_RG (void)
{
__asm
          LD      DE,#0x57FF   //    
LP_SSRG$: LD      H,D          //   
          LD      L,E          //   
          DEC     HL           //   
          LD      BC,#0x001F   // : 31 
          LDDR                 //    
          XOR     A            //    
          LD      (DE),A       //   ()   
          DEC     DE           //     
          BIT     6,D          //     ""  ,
          JR      NZ,LP_SSRG$  //     
__endasm;
}//SSRL_RG

/*
;--------------------------------------------------------------;
;     (55<=68)
;--------------------------------------------------------------;
*/
void Best40_SSRL_UP (void)
{
__asm
          LD      DE,#0x4000   //   
LP_SSU1$: PUSH    DE           //     
          LD      BC,#0x0020   //   - 32 
          LD      A,E          //   DE  
          ADD     A,C          //   .  
          LD      L,A          //  HL   
          LD      A,D          //  ,     8.
          JR      NC,GO_SSUP$  //      E -
          ADD     A,#0x08      //   32    L.  -
GO_SSUP$: LD      H,A          //   ,  H=D+8
          LDIR                 //    (32 )
          POP     DE           //    
          LD      A,H          // :      -
          CP      #0x58        //  ? (  23 )
          JR      NC,LP_SSU2$  //  ,    
          INC     D            // ---------------------------------;
          LD      A,D          //              DOWN_DE
          AND     #0x07        //   
          JR      NZ,LP_SSU1$  //       
          LD      A,E          //         
          ADD     A,#0x20      //         (  DE)
          LD      E,A          //
          JR      C,LP_SSU1$   //   :  DE -  
          LD      A,D          //   : DE -   
          SUB     #0x08        //    
          LD      D,A          //
          JR      LP_SSU1$     // ---------------------------------;
LP_SSU2$: XOR     A            //  
LP_SSU3$: LD      (DE),A       //     -
          INC     E            //     
          JR      NZ,LP_SSU3$  //  : 32 
          LD      E,#0xE0      //   
          INC     D            //  ()  
          BIT     3,D          //    ?
          JR      Z,LP_SSU2$   //  ,   
__endasm;
}//SSRL_UP

/*
;--------------------------------------------------------------;
;     (55<=73)
;--------------------------------------------------------------;
*/
void Best40_SSRL_DN (void)
{
__asm
          LD      DE,#0x57FF   //    
LP_SSD1$: PUSH    DE           //    
          LD      BC,#0x0020   //    
          LD      A,E          //   HL
          SUB     C            //   
          LD      L,A          //   ,
          LD      A,D          //   
          JR      NC,GO_SSDN$  //    
          SUB     #0x08        //   8  ():
GO_SSDN$: LD      H,A          //  HL= ; DE=
          LDDR                 //    
          POP     DE           //    
          BIT     6,H          //      ,
          JR      Z,LP_SSD2$   //     
          LD      A,D          // ---------------------------------;
          DEC     D            //               UP_DE
          AND     #0x07        //   
          JR      NZ,LP_SSD1$  //       
          LD      A,E          //        
          SUB     #0x20        //         (  DE)
          LD      E,A          //
          JR      C,LP_SSD1$   //   :  DE -  
          LD      A,D          //   : DE -   
          ADD     A,#0x08      //    
          LD      D,A          //
          JR      LP_SSD1$     // ---------------------------------;
LP_SSD2$: XOR     A            //  
LP_SSD3$: LD      (DE),A       //  
          DEC     E            //   :
          JR      NZ,LP_SSD3$  //  (31 )
          LD      (DE),A       //     
          LD      E,#0x1F      //    ()
          DEC     D            //      
          BIT     6,D          //      ?
          JR      NZ,LP_SSD2$  //  ,   
__endasm;
}//SSRL_DN

/*
;--------------------------------------------------------------;
;     (16<=17)
;--------------------------------------------------------------;
*/
void Best40_PSRL_LF (void)
{
__asm
          LD      HL,#0x57FF   //    
LP_PSL1$: OR      A            //    CF
          LD      B,#0x20      //    - 32 
LP_PSL2$: RL      (HL)         // CF<-[ ]<-CF ()
          DEC     HL           //     
          DJNZ    LP_PSL2$     //     
          BIT     6,H          //    ?
          JR      NZ,LP_PSL1$  //  ,   . 
__endasm;
}//PSRL_LF

/*
;--------------------------------------------------------------;
;     (17)
;--------------------------------------------------------------;
*/
void Best40_PSRL_RG (void)
{
__asm
          LD      HL,#0x4000   //    
          LD      C,#0xC0      //  - 192 
LP_PSR1$: OR      A            // CF=0    
          LD      B,#0x20      //     
LP_PSR2$: RR      (HL)         //    
          INC     HL           //    
          DJNZ    LP_PSR2$     //    - 32 
          DEC     C            //   
          JR      NZ,LP_PSR1$  //    ,  STOP
__endasm;
}//PSRL_RG

/*
;--------------------------------------------------------------;
;     (38<=91)
;--------------------------------------------------------------;
*/
void Best40_PSRL_UP (void)
{
__asm
          LD      DE,#0x4000   //    (. )
LP_PSU1$: LD      H,D          //   
          LD      L,E          //     HL
          LD      BC,#0x0020   //   
          INC     H            // ---------------------------------;
          LD      A,H          //             DOWN_HL
          AND     #0x07        //   
          JR      NZ,GO_PSUP$  //       
          LD      A,L          //         
          ADD     A,C          //         (  HL)
          LD      L,A          //  ( ADD A,C  ADD A,#08)
          JR      C,GO_PSUP$   //   :  HL -  
          LD      A,H          //   : HL -   
          SUB     #0x08        //    
          LD      H,A          // ---------------------------------;
GO_PSUP$: PUSH    HL           //    
          LDIR                 //   -
          POP     DE           // DE -   
          LD      A,H          //      
          CP      #0x58        //      ?
          JR      C,LP_PSU1$   //    ,  
          XOR     A            //     
LP_PSU2$: LD      (DE),A       //    
          INC     E            //    
          JR      NZ,LP_PSU2$  //     
__endasm;
}//PSRL_UP

/*
;--------------------------------------------------------------;
;     (38<=90)
;--------------------------------------------------------------;
*/
void Best40_PSRL_DN (void)
{
__asm
          LD      DE,#0x57FF   //    
LP_PSD1$: LD      H,D          //   
          LD      L,E          //     HL
          LD      BC,#0x0020   //    
          LD      A,H          // ---------------------------------;
          DEC     H            //               UP_HL
          AND     #0x07        //   
          JR      NZ,GO_PSDN$  //       
          LD      A,L          //        
          SUB     C            //         (  HL)
          LD      L,A          //    ( SUB C  SUB #08)
          JR      C,GO_PSDN$   //   :  HL -  
          LD      A,H          //   : HL -   
          ADD     A,#0x08      //    
          LD      H,A          // ---------------------------------;
GO_PSDN$: PUSH    HL           //    
          LDDR                 //  1   - 
          POP     DE           //     
          BIT     6,H          //       -
          JR      NZ,LP_PSD1$  //     
          XOR     A            //     
LP_PSD2$: LD      (DE),A       //   -   
          DEC     E            //    
          JR      NZ,LP_PSD2$  //    
          LD      (DE),A       //    
__endasm;
}//PSRL_DN

/*
;--------------------------------------------------------------;
;  (17<=21)
;--------------------------------------------------------------;
*/
void Best40_SCR_MRG (SYSTEM_ADDRESS scr_addr)
{
__asm
          LD      L,4(IX)      //     
          LD      H,5(IX)
          LD      DE,#0x4000   //   
LP_SCRM$: LD      A,(DE)       //    
          OR      (HL)         // ""     
          LD      (DE),A       //     
          INC     HL           //     
          INC     DE           //    
          LD      A,D          //   
          CP      #0x58        //   
          JR      C,LP_SCRM$   //   ,  
__endasm;
}//SCR_MRG

/*
;--------------------------------------------------------------;
;  (12<=18)
;--------------------------------------------------------------;
*/
void Best40_SCR_INV (void)
{
__asm
          LD      HL,#0x57FF   //    
LP_SCRI$: LD      A,(HL)       //     
          CPL                  //  
          LD      (HL),A       //   
          DEC     HL           //    
          BIT     6,H          //  ""  ,
          JR      NZ,LP_SCRI$  //   STOP,   
__endasm;
}//SCR_INV

/*
;--------------------------------------------------------------;
;   (20)
;--------------------------------------------------------------;
*/
void Best40_SINV_UD (SYSTEM_ADDRESS char_addr)
{
__asm
          LD      L,4(IX)      //     
          LD      H,5(IX)
          LD      D,H          //  
          LD      E,L          //    DE
          LD      B,#0x08      //   - 8 
LP_SIU1$: LD      A,(HL)       //    
          PUSH    AF           //    
          INC     HL           //     
          DJNZ    LP_SIU1$     //     
          LD      B,#0x08      //    
LP_SIU2$: POP     AF           //       -
          LD      (DE),A       //      
          INC     DE           //   
          DJNZ    LP_SIU2$     //    
__endasm;
}//SINV_UD

/*
;--------------------------------------------------------------;
;   (17<=19)
;--------------------------------------------------------------;
*/
void Best40_SINV_LR (SYSTEM_ADDRESS char_addr)
{
__asm
          LD      L,4(IX)      //     
          LD      H,5(IX)
          LD      B,#0x08      // : 8 
LP_SIL1$: LD      A,#0x01      //    A  1
LP_SIL2$: RR      (HL)         //    
          RLA                  //   -  ( CF)
          JR      NC,LP_SIL2$  //       CF
          LD      (HL),A       //   
          INC     HL           //   
          DJNZ    LP_SIL1$     //   8 
__endasm;
}//SINV_LR

/*
;--------------------------------------------------------------;
;     (26<=42)
;--------------------------------------------------------------;
*/
void Best40_SROTATE (SYSTEM_ADDRESS char_addr)
{
__asm
          LD      L,4(IX)      //     
          LD      H,5(IX)
          LD      B,#0x08      // 8    
LP_SRO1$: PUSH    HL           //    
          LD      A,#0x80      //  7-   
LP_SRO2$: RR      (HL)         //    
          RRA                  //        
          INC     HL           //    
          JR      NC,LP_SRO2$  //   7 .     CF
          POP     HL           //   
          PUSH    AF           // .   -  
          DJNZ    LP_SRO1$     //     
          LD      B,#0x08      //    - 
LP_SRO3$: POP     AF           //    
          LD      (HL),A       //   -    
          INC     HL           //   
          DJNZ    LP_SRO3$     //     (8 )
__endasm;
}//SROTATE

/*
;--------------------------------------------------------------;
;  (16<=21)
;--------------------------------------------------------------;
*/
void Best40_ACHANGE (SHORTINT attr_and, SHORTINT attr_or)
{
__asm
          LD      L,4(IX)      // L -     AND
          LD      H,5(IX)      // H -     OR
          LD      DE,#0x5AFF   //    
LP_ACHN$: LD      A,(DE)       //    
          AND     L            //   
          OR      H            //  
          LD      (DE),A       //     
          DEC     DE           //    
          BIT     3,D          //     ?
          JR      NZ,LP_ACHN$  //  ,   
__endasm;
}//ACHANGE

/*
;--------------------------------------------------------------;
;  (18<=22)
;--------------------------------------------------------------;
*/
void Best40_AREPLC (SHORTINT attr_from, SHORTINT attr_to)
{
__asm
          LD      E,4(IX)      // E -  
          LD      D,5(IX)      // D -  
          LD      HL,#0x5AFF   //    
LP_ARPL$: LD      A,(HL)       //     
          CP      E            //   ,  ?
          JR      NZ,GO_ARPL$  // ,  
          LD      (HL),D       // ,    
GO_ARPL$: DEC     HL           //    - 
          BIT     3,H          //    ?
          JR      NZ,LP_ARPL$  //  ,   
__endasm;
}//AREPLC

/*
;--------------------------------------------------------------;
;  (123<=263)
; 123=88+35 -    POINT
;--------------------------------------------------------------;
*/
void Best40_PAINT (SHORTINT x, SHORTINT y)
{
__asm
          LD      L,4(IX)      //  X  
          LD      H,5(IX)      //  Y  
          POP     IX           // . IX     RET NC/Z
          LD      A,H          //   Y  
          CP      #0xC0        //    :
          RET     NC           //   Y>=192,   
          SBC     A,A          // .. CF=1,  SBC A,A  A=#FF -
          PUSH    AF           //      
          PUSH    HL           //    
LP_PNT1$: POP     DE           //    X,Y . 
          INC     D            //  Y=#FF,   ,
          RET     Z            //      
          DEC     D            //  .  Y
          CALL    POINT$       //    - (E,D)
          JR      NZ,LP_PNT1$  //  ,    .
          EX      AF,AF        // A'=0, CF=0 - . 
LP_PNT2$: LD      A,E          //   X
          OR      A            //    ,
          JR      Z,GO_PNT1$   //      
          DEC     E            //  -   X
          CALL    POINT$       //    
          JR      Z,LP_PNT2$   //  " ", 
LP_PNT3$: INC     E            //     (X=X+1)
          JR      Z,LP_PNT1$   //  X>255,  .   
GO_PNT1$: CALL    POINT$       //    
          JR      NZ,LP_PNT1$  //  ,  .  
          LD      A,(HL)       //    ,
          OR      C            //      , 
          LD      (HL),A       //      
          LD      A,D          //   Y:
          OR      A            //    ,
          JR      Z,GO_PNT4$   //     .  
          DEC     D            //     (Y=Y-1)
          CALL    POINT$       //   
          JR      Z,GO_PNT2$   //   ,  
          EX      AF,AF        //   
          LD      A,B          //     
          JR      GO_PNT3$     //   
GO_PNT2$: EX      AF,AF        //   
          INC     A            //  A>0,    
          DEC     A            //     
          JR      NZ,GO_PNT3$  //    , -> 
          LD      A,C          //  -   -
          PUSH    DE           //  ,     
GO_PNT3$: EX      AF,AF        //   
          INC     D            //    
GO_PNT4$: LD      A,D          //   Y:
          CP      #0xBF        //  -  (  ),
          JR      NC,LP_PNT3$  //     .  
          INC     D            //  -    
          CALL    POINT$       //   
          JR      Z,GO_PNT5$   //   ,  
          EX      AF,AF        //   
          AND     A            //     
          JR      GO_PNT6$     //   
GO_PNT5$: EX      AF,AF        //   
          JR      C,GO_PNT6$   //   ,  
          SCF                  //     
          PUSH    DE           //      
GO_PNT6$: EX      AF,AF        //   
          DEC     D            //    
          JR      LP_PNT3$     //     
__endasm;
}//PAINT

/*
;--------------------------------------------------------------;
;        (35<=70)
;--------------------------------------------------------------;
*/
BOOLEAN Best40_POINT (SHORTINT x, SHORTINT y)
{
__asm
          LD      E,4(IX)      //  X
          LD      D,5(IX)      //  Y
          CALL    POINT$       //  POINT
          LD      L,A          // : 0 (FALSE)   0 (TRUE)
          POP     IX           // . IX     RET
          RET
POINT$:   //   ,  ZF=1 (Z),  ZF=0 (NZ)
          LD      B,#0x07      //    (#07)
          LD      A,D          //  Y-
          RRA                  //    8
          SCF                  //    
          RRA                  //   
          RRA                  //   
          AND     #0x5F        //    ( H):
          LD      H,A          //   %010yyyyy
          XOR     E            //  
          AND     B            //   
          XOR     E            //  
          RRCA                 //  
          RRCA                 //   
          RRCA                 //  ( L):
          LD      L,A          //   %yyyxxxxx
          LD      A,D          // 
          XOR     H            //  
          AND     B            //   
          XOR     H            //   
          LD      H,A          //    ( H)
          LD      A,E          //  
          AND     B            //     
          LD      B,A          //   (
          LD      A,#0x80      //   ).  7- 
          JR      Z,GO_PNT$    //       ,
LP_PNT$:  RRCA                 //     
          DJNZ    LP_PNT$      //    
GO_PNT$:  LD      C,A          //   .   . C
          AND     (HL)         //    
__endasm;
}//POINT

/*
;--------------------------------------------------------------;
;  (98<=196)
; 98+35=133 -    POINT
;--------------------------------------------------------------;
*/
void Best40_PFIGURE (SHORTINT x, SHORTINT y, SYSTEM_ADDRESS pattern)
{
__asm
          LD      E,4(IX)      //  X  
          LD      D,5(IX)      //  Y  
          LD      L,6(IX)      //   pattern  
          LD      H,7(IX)
          POP     IX           // . IX     RET Z
          DEC     HL           //     
LP_PFG3$: INC     HL           //    ,   ..
          LD      A,(HL)       //     
          OR      A            //    (   0)
          RET     Z            //    
          CP      #"0"         //   "  "?
          JR      NZ,GO_PFG6$  //  ,   
          LD      A,D          // y-  
          CP      #0xC0        //     
          JR      NC,LP_PFG3$  //  ,    
          PUSH    HL           //  -  
          PUSH    BC           //  ,   
          CALL    POINT$       //    
          LD      A,(HL)       //   
          OR      C            //     
          LD      (HL),A       //   ,  HL=,
          POP     BC           //    C   
          POP     HL           //  - 
          JR      LP_PFG3$     //  .  
GO_PFG6$: SUB     #"5"         //   ?
          JR      NZ,GO_PFG7$  //  ,     
          DEC     E            //  -  x-
GO_PFG7$: DEC     A            //  ?
          JR      NZ,GO_PFG8$  // , 
          INC     D            // ,  y-
GO_PFG8$: DEC     A            //  ""?
          JR      NZ,GO_PFG9$  // , 
          DEC     D            // ,  y-
GO_PFG9$: DEC     A            //    ?
          JR      NZ,LP_PFG3$  // ,   .  .
          INC     E            // ,  x-
          JR      LP_PFG3$     //     .  .
__endasm;
}//PFIGURE

/*
;--------------------------------------------------------------;
; end of         40 New Best Routines (graphic)                ;
;--------------------------------------------------------------;

: SAVE "nbestg.c" CODE 62000,861

           *   *   *
*/
